package Warn
{
	function GameConnection::AutoAdminCheck(%cl, %msg)
	{
		%cl.schedule(0, "AutoWarningCheck");
		return Parent::AutoAdminCheck(%cl, %msg);
	}
};
activatePackage("Warn");

function GameConnection::AutoWarningCheck(%cl)
{
	if($Warn[%cl.bl_id] != 0)
	{
		%cl.chatMessage("\c6You have <color:FF8000>"@NumToWord($Warn[%cl.bl_id])@" warning"@($Warn[%cl.bl_id]==1?"":"s")@"\c6 against you.");
		%cl.chatMessage("\c6Use \"\c2/viewMyWarning (\c3warning number\c2)\c6\" to see what the reason for a given warning was.");
	}
}

function servercmdWarn(%cl, %targ, %m1, %m2, %m3, %m4, %m5, %m6, %m7, %m8, %m9, %m10, %m11, %m12, %m13, %m14, %m15, %m16, %m17) //servercmds can only have 19 parameters, including the client, so any extension to this is worthless
{
	if(%targ $= "")
		return;
	if(%cl.isSuperAdmin || %cl.isAdmin)
	{
		%msg = trim(strReplace(%m1 SPC %m2 SPC %m3 SPC %m4 SPC %m5 SPC %m6 SPC %m7 SPC %m8 SPC %m9 SPC %m10 SPC %m11 SPC %m12 SPC %m13 SPC %m14 SPC %m15 SPC %m16 SPC %m17, "_", " "));
		if(%targ == 0 && %targ !$= "0")
		{
			%targ = findClientByName(%targ);
			if(!isObject(%targ)) return;
			%cl.chatMessage("\c6Warn "@%targ.name@"? (/yes or /no)");
			%cl.warnTarget = %targ.bl_id;
			%cl.warnMsg = %msg;
			return;
		}
		else if(%vict = isObject(findClientByName(%targ)))
		{
			if(%cl.warnTarget $= "")
			{
				%cl.chatMessage("\c6Warn "@%vict.name@"? (/yes or /no)");
				%cl.warnTarget = %vict.bl_id;
				%cl.warnMsg = %msg;
				return;
			}
		}
		else if(isObject(findClientByBL_ID(%targ)))
			%targ = findClientByBL_ID(%targ);
		else
		{
			%blid = %targ;
			if(isObject(%group = ("Brickgroup_"@%targ).getID()))
				%name = %group.name;
			else
				%name = "BL_ID: "@%targ;
		}
		if(isObject(%targ))
		{
			if(%targ.bl_id !$= "")
			{
				%blid = %targ.bl_id;
				%name = %targ.name;
			}
		}
		else if(%blid $= "")
			return %cl.chatMessage("\c6Target not found.");
			
		%warn = ($Warn[%blid]++);
		setMsg(%warn, %blid, %msg);
		%action = $WarningAction_[%warn];
		if(%action $= "")
			%action = $WarningAction_Default;
		switch$(getWord(%action, 0))
		{
			case "NOTIFY":
				if(isObject(%targ)) %targ.centerPrint("\c6"@%cl.name@" has warned you for the following reason:<br>\c6\""@%msg@"\"", 10);
			case "KICK":
				if(isObject(%targ)) %targ.delete(%msg);
			case "BAN":
				servercmdBan(%cl, (isObject(%targ) ? %targ : 0), %blid, ((%time = getWord(%action, 1)) $= "" ? 5 : %time), %msg);
			default:
				if(isObject(%targ)) %targ.delete(%msg);
		}
		messageAll('MsgAdminForce', "<color:00ff00>"@%cl.name@"\c6 has increased <color:00ff00>"@%name@"\c6"@(getSubStr(%name,strLen(%name)-1,1)$="s"?"\'":"\'s")@" warnings to <color:00ff00>"@NumToWord($Warn[%blid])@"\c6.");
		messageAll('', "\c6Reason: "@%msg);
		export("$Warn*", "config/server/Warnings.cs");
	}
}

function servercmdViewWarning(%cl, %blid, %num)
{
	if(%blid $= "")
		%blid = %cl.bl_id;
	if(%num < 0)
		%cl.chatMessage("\c6Yes, you're very clever. Now stop trying to break my script and use it correctly.");
	else if(%num == 0)
		if(%blid == %cl.bl_id)
			%cl.chatMessage("\c6You have "@NumToWord($Warn[%cl.bl_id]+0)@" warning"@($Warn[%cl.blid]==1?"":"s")@".");
		else
			%cl.chatMessage("\c2BL_ID "@%blid@"\c6 has "@NumToWord($Warn[%blid]+0)@" warning"@($Warn[%blid]==1?"":"s")@".");
	else if(%num <= $Warn[%blid])
		if(%blid == %cl.bl_id)
			%cl.chatMessage("\c2Your "@OrdinalNumToWord(%num)@" message was "@getMsg(%num, %cl.bl_id)@".");
		else
			%cl.chatMessage("\c2BL_ID "@%blid@"\c6's "@OrdinalNumToWord(%num)@" message was "@getMsg(%num, %blid)@".");
	else
		if(%blid == %cl.bl_id)
			%cl.chatMessage("\c2You only have "@NumToWord($Warn[%cl.bl_id]+0)@" warning"@($Warn[%cl.blid]==1?"":"s")@".");
		else
			%cl.chatMessage("\c2BL_ID "@%blid@"\c6 only has "@NumToWord($Warn[%blid]+0)@" warning"@($Warn[%blid]==1?"":"s")@".");
}

function servercmdViewMyWarning(%cl, %num)
{ servercmdViewWarning(%cl, %cl.bl_id, %num); }

function setMsg(%num, %blid, %msg)
{ $Warn[%num, %bl_id] = %msg; }

function getMsg(%num, %blid)
{ return $Warn[%num, %bl_id]; }

function servercmdYes(%cl)
{
	if(%cl.isSuperAdmin || %cl.isAdmin)
		if(%cl.warnTarget !$= "")
		{
			servercmdWarn(%cl, %cl.warnTarget, %cl.warnMsg);
			%cl.warnTarget = "";
			%cl.warnMsg = "";
		}
}

function servercmdNo(%cl)
{
	if(%cl.isSuperAdmin || %cl.isAdmin)
		if(%cl.warnTarget !$= "")
		{
			%cl.warnTarget = "";
			%cl.warnMsg = "";
		}
}

function loadWarningLevels(%path)
{
	%file = new fileObject(){};
	%file.openForRead(%path);
	$WarningAction_Default = %file.readLine();
	while(!%file.isEOF())
		$WarningAction_[%line++] = %file.readLine();
	%file.close();
	%file.delete();
}

exec("./NumToWord.cs");   //Load the Num To Word function.

if(isFile("config/server/Warnings.cs"))
	exec("config/server/Warnings.cs");

if(!isFile("config/server/WarningLevels.txt"))
	fileCopy("Add-Ons/Server_Warning/Default.txt", "config/server/WarningLevels.txt");
loadWarningLevels("config/server/WarningLevels.txt");